Package: ISAR
Type: Package
Title: Introduction to Sports Analytics using R (ISAR) Data
Version: 1.0.5
Authors@R: c(
    person("Ryan", "Elmore", email = "Ryan.Elmore@du.edu", role = c("cre", "aut")))
Maintainer: Ryan Elmore <Ryan.Elmore@du.edu>
Description: We provide data sets used in the textbook "Introduction to Sports Analytics using R" by Elmore and Urbaczweski (2025). 
License: MIT + file LICENSE
Encoding: UTF-8
LazyData: true
Depends: R (>= 3.5)
RoxygenNote: 7.3.3
URL: https://github.com/rtelmore/ISAR
BugReports: https://github.com/rtelmore/ISAR/issues
NeedsCompilation: no
Packaged: 2026-04-21 19:23:42 UTC; ryanelmore
Author: Ryan Elmore [cre, aut]
Repository: CRAN
Date/Publication: 2026-04-21 22:32:20 UTC
Built: R 4.6.0; ; 2026-04-26 20:26:58 UTC; unix

# ISAR

[![Python package](https://github.com/equinor/isar/actions/workflows/pythonpackage.yml/badge.svg)](https://github.com/equinor/isar/actions/workflows/pythonpackage.yml)
[![Code style: black](https://img.shields.io/badge/code%20style-black-000000.svg)](https://github.com/psf/black)
[![License](https://img.shields.io/badge/License-EPL_2.0-blue.svg)](https://opensource.org/licenses/EPL-2.0)

ISAR - Integration and Supervisory control of Autonomous Robots - is a tool for integrating robot applications into
operator systems. Through the ISAR API you can send commands to a robot to do missions and collect results from the
missions.

## Getting started

Steps:

- Install
- Integrate a robot
- Run the ISAR server
- Run a robot mission

### Install

For local development, please fork the repository. Then, clone and install in the repository root folder:

```
git clone https://github.com/<path_to_parent>/isar
cd isar
pip install -r requirements.txt -e ".[dev]"
```

Verify that you can run the tests:

```bash
pytest .
```

The repository contains a configuration file for installing pre-commit hooks. Currently, [black](https://github.com/psf/black) and a mirror of [mypy](https://github.com/pre-commit/mirrors-mypy) are configured hooks. Install with:

```
pre-commit install
```

Verify that pre-commit runs:

```
pre-commit
```

pre-commit will now run the installed hooks before code is commited to git. To turn pre-commit off, run:

```
pre-commit uninstall
```

### Robot integration

To connect the state machine to a robot in a separate repository, it is required that the separate repository implements
the [robot interface](https://github.com/equinor/isar/blob/main/src/robot_interface/robot_interface.py).
The separate repository should also have a settings.env file in a config folder where `CAPABILITIES` and `ROBOT_MODEL` are set.
A mocked robot can be found in [this repository](https://github.com/equinor/isar-robot). Install the repo, i.e:

```bash
pip install isar-robot
```

NB: isar-robot has not been published to PyPi for some time, and needs to be downloaded directly
from git to work.

Then, ensure the `ISAR_ROBOT_PACKAGE` variable in [settings.env](./src/isar/config/settings.env)
is set to the name of the package you installed. `isar_robot` is set by default. See the section
for [configuration](#configuration) for overwriting configuration.

If you have the robot repository locally, you can simply install through

```bash
pip install -e /path/to/robot/repo/
```

#### Running ISAR with a robot simulator

A simulator based on the open source robot Turtlebot3 has been implemented for use with ISAR and may be
found [here](https://github.com/equinor/isar-turtlebot). Follow the installation instructions for the simulator and
install `isar-turtlebot` in the same manner as given in the [robot integration](#robot-integration) section. Overwrite
the following configuration variables:

```bash
ISAR_ROBOT_PACKAGE = isar_turtlebot
ISAR_DEFAULT_MAP = turtleworld
```

### Run with make
Common commands for the project are in [Makefile](./Makefile).
This requires the CLI program `make`.

Usage:
```bash
make <command-in-makefile> # for example: make run
```

### Run ISAR server

To run ISAR:

```bash
isar-start
```

Note, running the full system requires that an implementation of a robot has been installed. See
this [section](#robot-integration) for installing a mocked robot or a Turtlebot3 simulator.

### Running a robot mission

Once the application has been started the swagger site may be accessed at

```
http://localhost:3000/docs
```

Execute the `/schedule/start-mission` endpoint with the 'mission_definition' value in the body containing a JSON representing a mission definition (see `StartMissionDefinition` in [start_mission_definition.py](./src/isar/apis/models/start_mission_definition.py)). 

Here is an example body:
{
   'mission_definition': {
      'id': 'example ID',
      'tasks': [
         {
            'id': 'example ID',
            'type': 'inspection',
            'pose': {
               'position': {
                  'x': 1.0,
                  'y': 1.0,
                  'z': 1.0,
                  'frame_name': 'robot'
               },
               'orientation': {
                  'x': 0.0,
                  'y': 0.0,
                  'z': 0.0,
                  'w': 0.0,
                  'frame_name': 'robot'
               },
               'frame_name': 'robot'
            },
            'inspection': {
               'type': 'Image',
               'inspection_target': {
                  'x': 5.0,
                  'y': 5.0,
                  'z': 5.0,
                  'frame_name': 'robot'
               },
               'inspection_description': 'Example description,
               'duration': None
            },
            'tag': 'example_tag',
            'zoom': None
         }
      ],
      'name': 'Example name',
      'start_pose': None
   }
}

### Configuration

The system consists of many configuration variables which may alter the functionality. As an example, it is possible to
add multiple storage handlers as described in the [storage](#storage) section.

There are two methods of specifying configuration.

1. Override the default value by setting an environment variable.

   Every configuration variable is defined in [settings.py](./src/isar/config/settings.py), and they may all be
   overwritten by specifying the variables in the environment instead. Note that the configuration variable must be
   prefixed with `ISAR_` when specified in the environment. So for the `ROBOT_PACKAGE`configuration variable:

   ```shell
   export ISAR_ROBOT_PACKAGE=isar_turtlebot
   ```

   This means ISAR will connect to `isar_turtlebot` robot package.

2. Adding environment variables through [settings.env](./src/isar/config/settings.env).

   By adding environment variables with the prefix `ISAR_` to the [settings.env](./src/isar/config/settings.env) file
   the configuration variables will be overwritten by the values in this file.

### Setup for testing
To be able to execute the tests you need to set the `ISAR_ENV` environment variable beforehand. Depending on your operating system and the command line you are using you can use one of the following commands:

**Bash/Zsh**
```bash
export ISAR_ENV=test
```
**Windows Command prompt**
```cmd
set ISAR_ENV=test
```

Remember to set `ISAR_ENV` back to `None` when you want to run `isar-start` afterwards.

### Running tests

After following the steps in [Development](#install), you can run the tests:

```bash
pytest .
```

To create an interface test in your robot repository, use the function `interface_test` from `robot_interface`. The
argument should be an interface object from your robot specific implementation.
See [isar-robot](https://github.com/equinor/isar-robot/blob/main/tests/interfaces/test_robotinterface.py) for example.

#### Integration tests

Integration tests can be found [here](https://github.com/equinor/isar/tree/main/tests/integration) and have been created
with a simulator in mind. The integration tests will not run as part of `pytest .` or as part of the CI/CD pipeline. To
run the integration tests please follow the instructions in [this section](#running-isar-with-a-robot-simulator) for
setting up the `isar-turtlebot` implementation with simulator and run the following command once the simulation has been
launched.

```bash
pytest tests/integration
```

Note that these tests will run towards the actual simulation (you may monitor it through Gazebo and RVIZ) and it will
take a long time.

### Documentation

To build the project documentation, run the following commands:

```bash
cd docs
make docs
```

The documentation can now be viewed at `docs/build/html/index.html`.

## Components

The system consists of two main components.

1. State machine
1. FastAPI

### State machine

The state machine handles interaction with the robots API and monitors the execution of missions. It also enables
interacting with the robot before, during and after missions.

In general the states

```
States.Stopping,
States.Monitor,
States.Paused,
```

indicates that the state machine is already running. For running a mission the state machine need to be in the states

```
States.Home, States.AwaitNextMission or States.ReturningHome
```

### FastAPI

The FastAPI establishes an interface to the state machine for the user. As the API and state machine are separate
threads, they communicate through python queues. FastAPI runs on an ASGI-server, specifically uvicorn. The
FastAPI-framework is split into routers where the endpoint operations are defined.

## Storage

The storage modules that are used is defined by the `ISAR_STORAGE` configuration variable. This can be changed by
overriding the configuration through an environment variable. It accepts a json encoded list and will use each element
in the list to retrieve the corresponding handler. The current options are

```
ISAR_STORAGE = '["local", "blob"]'
```

Note that the `blob` option requires special configuration to authenticate to these endpoints.

### Implement your own storage module

You can create your own storage module by implementing the [storage interface](./src/isar/storage/storage_interface.py)
and adding your storage module to the selection [here](./src/isar/modules.py). Note that you must add your module as an
option in the dictionary.

## API authentication

The API has an option to include user authentication. This can be enabled by setting the environment variable

```
ISAR_AUTHENTICATION_ENABLED = true
```

By default, the `local` storage module is used and API authentication is disabled. If using Azure Blob Storage a set of
environment variables must be available which gives access to an app registration that may use the storage account.
Enabling API authentication also requires the same environment variables. The required variables are

```
AZURE_CLIENT_ID
AZURE_TENANT_ID
AZURE_CLIENT_SECRET
ISAR_BLOB_STORAGE_ACCOUNT
```

## MQTT communication

ISAR is able to publish parts of its internal state to topics on an MQTT broker whenever they change. 
The connection to the broker will be determined by the following configuration values in `settings.py`

```
ISAR_MQTT_USERNAME
ISAR_MQTT_HOST
ISAR_MQTT_PORT
```

The default values of these are overwritten by the environment in a file you can create called `.env`.

To specify broker password, add the following environment variable to a .env file in the root of the repository:

```
ISAR_MQTT_PASSWORD
```

If not specified the password will default to an empty string.

## Running several ISAR instances locally

To run several ISAR instances in parallel locally:

1. Generate a guid: https://www.guidgenerator.com/
2. Open a new terminal in the isar folder
3. Run the following command before running main.py:

```
export ISAR_API_PORT=port_name_higher_than_1024 ISAR_ISAR_ID=guid ISAR_ROBOT_NAME=random_robot_name
```

# Dependencies

The dependencies used for this package are listed in `pyproject.toml` and pinned in `requirements.txt`. This ensures our builds are predictable and deterministic. This project uses `pip-compile` (from [`pip-tools`](https://github.com/jazzband/pip-tools)) for this:

```
pip-compile --output-file=requirements.txt pyproject.toml
```

To update the requirements to the latest versions, run the same command with the `--upgrade` flag:

```
pip-compile --output-file=requirements.txt pyproject.toml --upgrade
```

# Contributions

Equinor welcomes all kinds of contributions, including code, bug reports, issues, feature requests, and documentation
Please initiate your contribution by creating an [issue](https://github.com/equinor/isar/issues) or by forking the
project and making a pull requests. Commit messages shall be written according to [this guide](https://cbea.msgit-commit/).

# To generate state transition diagram

The 'update_state_diagram.py' file can be used to generate a state transition
diagram of the ISAR state machine. To do so, simply run the file from the top
level folder (it assumes that the main folder is the current woking directory).
This will then generate a .mmd file (diagram.mmd), which is a Mermaid markdown
file, which can be converted to other formats if needed.

To convert a .mmd file to a .svg file, first run 

    npm install -g @mermaid-js/mermaid-cli

and then

    mmdc -i diagram.mmd -o diagram.svg

This can then be opened with a browser. Other formats such as PNG are supported,
but the resolution can be a limitation for large diagrams.

# Limitations

Currently the script assumes that all transitions from one state to another
are made within each state file. This would not be the case if a utility
function or some other imported function made the transition call instead. This
is because it generates the transitions based on which states are imported from
another state. If no import statement is found, then we assume that there is
not a transition.

Alembic is used to migrate the databases. [link](https://alembic.sqlalchemy.org/en/latest/front.html#installation)

# How to

Requirements:
1. Set the correct environment variable connection string `ISAR_PERSISTENT_STORAGE_CONNECTION_STRING` for the database.

<details>
<summary>
Creating new migrations
</summary>

```bash
alembic revision --autogenerate -m "Migration name"
```

This will compare what is in the metadata of sqlalchemy Base with what is in the database and create a migration for it. 
</details>

<details open>
<summary>
Checking if database is up-to-date
</summary>

```bash
alembic check
```
</details>

<details>
<summary>
Run migrations
</summary>

```bash
alembic upgrade head
```
</details>


# Notes:
1. The model files are located [here](../src/isar/services/service_connections/persistent_memory.py). 

#' Draftkings Showdown Game (Clippers vs. Mavericks)
#'
#' A dataset containing the Draftkings salary information for Game 3 of the
#'  2021 NBA Playoffs between the Los Angeles Clippers and the Dallas Mavericks.
#'
#' @format A data frame with 68 rows and 9 variables:
#' \describe{
#'   \item{position}{real-life roster position of the player}
#'   \item{name_id}{player name and Draftkings ID}
#'   \item{name}{player name}
#'   \item{id}{Draftkings player ID}
#'   \item{roster_position}{Draftkings roster position}
#'   \item{salary}{player salary}
#'   \item{game_info}{game information for the players}
#'   \item{team_abbrev}{player team as an abbreviation}
#'   \item{avg_points_per_game}{player average Draftkings points per game}
#' }
#' @source Draftkings Contest Page
"dk_lac_dal"

#' NHL's Colorado Avalanche Player Statistics
#'
#' A dataset containing the statistics for all Colorado Avalanche players on the 2021-2 roster
#'
#' @format A data frame with 196 rows and 50 variables:
#' \describe{
#'   \item{person_id}{NHL API Player ID}
#'   \item{person_full_name}{Player full name}
#'   \item{season}{Season}
#'   \item{season_start}{Season start}
#'   \item{stat_assists}{Assists}
#'   \item{stat_goals}{Goals}
#'   \item{stat_pim}{Penalty minutes}
#'   \item{stat_games}{Games played}
#'   \item{stat_penalty_minutes}{Penalty minutes}
#'   \item{stat_plus_minus}{Plus-minus value}
#'   \item{stat_points}{Points }
#'   \item{stat_power_play_goals}{Power play goals}
#'   \item{stat_game_winning_goals}{Game winning goals}
#'   \item{stat_short_handed_goals}{Short handed goals}
#'   \item{stat_shots}{Shots}
#'   \item{stat_shot_pct}{Shot percentage}
#'   \item{stat_time_on_ice}{Time on ice}
#'   \item{stat_hits}{Hits}
#'   \item{stat_power_play_points}{Power play points}
#'   \item{stat_power_play_time_on_ice}{Power play time on ice}
#'   \item{stat_even_time_on_ice}{Even play time on ice}
#'   \item{stat_face_off_pct}{Face off percentage}
#'   \item{stat_over_time_goals}{Overtime goals}
#'   \item{stat_short_handed_points}{Short handed points}
#'   \item{stat_short_handed_time_on_ice}{Short handed time on ice}
#'   \item{stat_blocked}{Blocks}
#'   \item{stat_shifts}{Shifts}
#'   \item{stat_save_percentage}{Save percentage}
#'   \item{stat_goal_against_average}{Goals against average}
#'   \item{stat_ot}{OT}
#'   \item{stat_shutouts}{Shutouts}
#'   \item{stat_ties}{Ties}
#'   \item{stat_wins}{Wins}
#'   \item{stat_losses}{Losses}
#'   \item{stat_saves}{Saves}
#'   \item{stat_power_play_saves}{Power play saves}
#'   \item{stat_short_handed_saves}{Short handed saves}
#'   \item{stat_even_saves}{Even play saves}
#'   \item{stat_short_handed_shots}{Short handed shots}
#'   \item{stat_even_shots}{Even play shots}
#'   \item{stat_power_play_shots}{Power play shots}
#'   \item{stat_games_started}{Games started}
#'   \item{stat_shots_against}{Shots against}
#'   \item{stat_goals_against}{Goals against}
#'   \item{stat_power_play_save_percentage}{Power play save percentage}
#'   \item{stat_short_handed_save_percentage}{Short handed save percentage}
#'   \item{stat_even_strength_save_percentage}{Even strength save percentage}
#'   \item{team_name}{Team name}
#'   \item{team_link}{Team link}
#'   \item{team_id}{Team ID}
#' }
#' @source \url{https://www.nhl.com/stats/}
"avs_stats_2021"

#' 2021 NHL Colorado Avalanche Roster (from NHL's API)
#'
#' A dataset containing the NHL's Avalanche Roster
#'
#' @format A data frame with 28 rows and 8 variables:
#' \describe{
#'   \item{jersey_number}{player jersey number}
#'   \item{person_id}{player ID}
#'   \item{person_full_name}{player full name}
#'   \item{person_link}{API link to player data}
#'   \item{position_code}{position abbreviation}
#'   \item{position_name}{position name}
#'   \item{position_type}{position type}
#'   \item{position_abbreviation}{another position abbreviation}
#' }
#' @source \url{https://www.nhl.com/stats/}
"avs_roster_2021"

#' 2021-2022 English Premier League Goalkeeper Statistics
#'
#' A dataset containing individual goalkeeper statistics for the English Premier League's 2021 - 2022 season
#'
#' @format A data frame with 314 rows and 13 variables:
#' \describe{
#'   \item{player}{Player name}
#'   \item{nation}{Player home country}
#'   \item{pos}{Player position}
#'   \item{squad}{Player team}
#'   \item{age}{Age of player}
#'   \item{born}{Birth year of player}
#'   \item{min_p90}{Total minutes played in the season per ninety minutes}
#'   \item{goals}{Goals scored against player}
#'   \item{pk_allowed}{Penalty kick goals scored against player}
#'   \item{free_kick_goals}{Free kick goals scored against player}
#'   \item{corner_kick_goals}{Corner kick goals scored against player}
#'   \item{own_goals_against}{Own goals scored against player}
#'   \item{post_shot_xG}{Post-shot expected goals}
#'   \item{post_shot_xG_per_shot_on_target}{Post-shot expected goals per shot on target}
#'   \item{post_shot_xG_minus_goals}{Post-shot expected goals minus goals per shot on target}
#'   \item{post_shot_xG_minus_goals_p90}{Post-shot expected goals minus goals per shot on target per ninety minutes}
#'   \item{launch_completed}{Passes longer than 40 yards (launch) completed}
#'   \item{launch_attempt}{Passes longer than 40 yards attempted}
#'   \item{launch_completion_percent}{Passes longer than 40 yards (launch) completion percentage}
#'   \item{pass_attempt}{Passes attempted}
#'   \item{throw_attempt}{Throws attempted}
#'   \item{pass_launch_percent}{Percentage of passes launched}
#'   \item{avg_pass_len}{Average pass length}
#'   \item{goal_kick_attempt}{Goal kick attempts}
#'   \item{gk_launch_percent}{Percentage of goals kicks launched}
#'   \item{avg_gk_len}{Average goal kick length}
#'   \item{crosses_faced}{Number of crosses faced}
#'   \item{crosses_stopped}{Number of crosses stopped}
#'   \item{stop_percent}{Cross stop percentage}
#'   \item{def_actions_out_pen_area}{Defensive actions outside the penalty area}
#'   \item{def_actions_out_pen_area_p90}{Defensive actions outside the penalty area per ninety minutes}
#'   \item{avg_dist_def_actions}{Average distance from goal of defensive actions}
#' }
#'
#' @source \url{https://fbref.com/en/comps/9/2021-2022/keepersadv/2021-2022-Premier-League-Stats}
"epl_gk_stats_2022"

#' 2021 NBA Advanced Statistics (Team) for the 2020-21 Season
#'
#' A dataset containing the NBA Four Factor table on nba.com
#'
#' @format A data frame with 2160 rows and 29 variables:
#' \describe{
#'   \item{idGame}{Game ID on nba.com}
#'   \item{slugTeam}{Team abbreviation}
#'   \item{idTeam}{Team ID on nba.com}
#'   \item{pctAST}{Assist percentage}
#'   \item{pctOREB}{Offensive rebound percentage}
#'   \item{pctDREB}{Defensive rebound percentage}
#'   \item{pctTREB}{Total rebound percentage}
#'   \item{pctTOVE}{Turnover percentage (one)}
#'   \item{pctTOVTeam}{Turnover percentage (two)}
#'   \item{pctEFG}{Effective field goal percentage}
#'   \item{pctTS}{True Shooting percentage}
#'   \item{pctUSG}{Usage metric}
#'   \item{pctUSGE}{Usage percentage}
#'   \item{teamName}{Team Mascot}
#'   \item{cityTeam}{City of slugTeam}
#'   \item{minExact}{Total minutes played}
#'   \item{ortgE}{offensive rating (effective ?)}
#'   \item{ortg}{offensive rating}
#'   \item{drtgE}{defensive rating (effective ?)}
#'   \item{drtg}{defensive rating}
#'   \item{netrtgE}{net rating (effective ?)}
#'   \item{netrtg}{net rating}
#'   \item{ratioASTtoTOV}{Assists to turnover ratio}
#'   \item{ratioAST}{Assist ratio}
#'   \item{paceE}{pace (effective ?)}
#'   \item{pace}{pace}
#'   \item{pacePer40PACE_PER40}{pace per forty minutes}
#'   \item{possessions}{team possessions in game}
#'   \item{ratioPIE}{Player impact estimate}
#' }
#' @source \url{http://asbcllc.com/nbastatR/reference/box_scores.html}
"nba_adv_team_2021"

#' NBA Game Logs for the 2022-23 Season
#'
#' A dataset containing the NBA Games table on nba.com
#'
#' @format A data frame with 2460 rows and 29 variables:
#' \describe{
#'   \item{season_id}{Season in which the game was played (YYYY)}
#'   \item{team_id}{Team ID on nba.com}
#'   \item{team_abbreviation}{Team abbreviation on nba.com}
#'   \item{team_name}{Team name on nba.com}
#'   \item{game_id}{Game ID on nba.com}
#'   \item{game_date}{Date in YYYY-MM-DD}
#'   \item{matchup}{Team One vs. Team Two}
#'   \item{wl}{Win or Loss}
#'   \item{min}{Minutes in the game}
#'   \item{fgm}{Team Field goals made}
#'   \item{fga}{Team Field goal attempts}
#'   \item{fg_pct}{Team field goal percentage}
#'   \item{fg3m}{Team three point field goals made}
#'   \item{fg3a}{Team three point field goal attempts}
#'   \item{fg3_pct}{Team three point field goal percentage}
#'   \item{ftm}{Team free throws made}
#'   \item{fta}{Team free throw attempts}
#'   \item{ft_pct}{Team free throw percentage}
#'   \item{oreb}{Team offensive rebounds}
#'   \item{dreb}{Team defensive rebounds}
#'   \item{reb}{Team total rebounds}
#'   \item{ast}{Team total assists}
#'   \item{stl}{Team total steals}
#'   \item{blk}{Team total blocks}
#'   \item{tov}{Team total turnovers}
#'   \item{pf}{Team total personal fouls}
#'   \item{pts}{Team total points scored}
#'   \item{plus_minus}{Margin of game as Team score minus Opponent score}
#'   \item{video_available}{Logical if game video exists}
#' }
#' @source \url{http://asbcllc.com/nbastatR/reference/game_logs.html}
"nba_games_2023"

#' 2021 NBA Game Logs for the 2020-21 Season
#'
#' A dataset containing the NBA Games table on nba.com
#'
#' @format A data frame with 1832 rows and 47 variables:
#' \describe{
#'   \item{yearSeason}{Season in which the game was played (YYYY)}
#'   \item{slugSeason}{Season in which the game was played (YYYY-YY)}
#'   \item{slugLeague}{Always given as NBA}
#'   \item{typeSeason}{Regular season data}
#'   \item{dateGame}{Date in YYYY-MM-DD}
#'   \item{idGame}{Game ID on nba.com}
#'   \item{numberGameTeamSeason}{slugTeam game number in the season}
#'   \item{nameTeam}{Full team name}
#'   \item{idTeam}{Team ID on nba.com}
#'   \item{isB2B}{Logical for back-to-back game}
#'   \item{isB2BFirst}{Logical for first game of back-to-back game}
#'   \item{isB2BSecond}{Logical for second game of back-to-back game}
#'   \item{locationGame}{Home (H) or Away (A)}
#'   \item{slugMatchup}{Team One vs. Team Two}
#'   \item{slugTeam}{Team abbreviation}
#'   \item{countDaysRestTeam}{Days between previous game and this game}
#'   \item{countDaysNextGameTeam}{Days until next game}
#'   \item{slugOpponent}{Opponent abbreviation}
#'   \item{slugTeamWinner}{Team that won (abbreviation)}
#'   \item{slugTeamLoser}{Team that lost (abbreviation)}
#'   \item{outcomeGame}{Result for slugTeam (W or L)}
#'   \item{isWin}{Logical for slugTeam winning}
#'   \item{fgmTeam}{slugTeam field goals made}
#'   \item{fgaTeam}{slugTeam field goal attempts}
#'   \item{pctFGTeam}{slugTeam field goal percentage}
#'   \item{fg3mTeam}{slugTeam three point field goals made}
#'   \item{fg3aTeam}{slugTeam three point field goal attempts}
#'   \item{pctFG3Team}{slugTeam three point field goal percentage}
#'   \item{pctFTTeam}{slugTeam free throw percentage}
#'   \item{hasVideo}{Logical if game video exists}
#'   \item{fg2mTeam}{slugTeam two point field goals made}
#'   \item{fg2aTeam}{slugTeam two point field goal attempts}
#'   \item{pctFG2Team}{slugTeam two point field goal percentage}
#'   \item{minutesTeam}{Total minutes played}
#'   \item{ftmTeam}{slugTeam free throws made}
#'   \item{ftaTeam}{slugTeam free throw attempts}
#'   \item{orebTeam}{slugTeam offensive rebounds}
#'   \item{drebTeam}{slugTeam defensive rebounds}
#'   \item{trebTeam}{slugTeam total rebounds}
#'   \item{astTeam}{slugTeam total assists}
#'   \item{stlTeam}{slugTeam total steals}
#'   \item{blkTeam}{slugTeam total blocks}
#'   \item{tovTeam}{slugTeam total turnovers}
#'   \item{pfTeam}{slugTeam total personal fouls}
#'   \item{ptsTeam}{slugTeam total points scored}
#'   \item{plusminusTeam}{Margin of game as slugTeam score minus slugOpponent score}
#'   \item{urlTeamSeasonLogo}{url of slugTeam logo}
#' }
#' @source \url{http://asbcllc.com/nbastatR/reference/game_logs.html}
"nba_games_2021"

#' 2025 Masters Tournament Scores
#'
#' A data frame containing the scores from the 2025 Masters Golf Tournament.
#'
#' @format A data frame with 95 rows and 9 variables:
#' \describe{
#'   \item{pos}{finishing position for a player}
#'   \item{player_name}{name of the golfer}
#'   \item{nationality}{nationality of the golfer}
#'   \item{score}{final score relative to par}
#'   \item{round_1}{number of strokes from the first round}
#'   \item{round_2}{number of strokes from the second round}
#'   \item{round_3}{number of strokes from the third round}
#'   \item{round_4}{number of strokes from the fourth round}
#'   \item{total}{total strokes from all rounds}
#' }
#' @source \url{https://www.espn.com/golf/leaderboard/_/tournamentId/401703504}
"masters_2025"

#' 2025 WNBA Seattle Storm Shots
#'
#' A dataset containing all Seattle Storm shots in the 2025 season
#'
#' @format A data frame with 6347 rows and 3 variables:
#' \describe{
#'.  \item{coordinate_x}{X Coordinate of Shot}
#'.  \item{coordinate_y}{Y Coordinate of Shot}
#'   \item{scoring_play}{Made or Missed Shot}
#' }
#' @source \url{https://wehoop.sportsdataverse.org}
"wnba_seattle_pbp_2025"

#' 2022 Official World Golf Rankings
#'
#' A dataset containing the Official World Golf Rankings in June 2022
#'
#' @format A data frame with 300 rows and 2 variables:
#' \describe{
#'   \item{WGR_June_2022}{official golf world ranking}
#'   \item{Player_initial_last}{initial of first name and complete last name of player}
#' }
#' @source \url{https://www.owgr.com/archive/archive.sps?iType=1747}
"ow_golf_rankings"

#' 2022 NWSL Player Statistics
#'
#' A dataset containing individual player statistics for the National Women's Soccer League
#'
#' @format A data frame with 314 rows and 13 variables:
#' \describe{
#'   \item{player}{Player name}
#'   \item{nation}{Player home country}
#'   \item{pos}{Player position}
#'   \item{squad}{Player team}
#'   \item{age}{Age of player}
#'   \item{mp}{Matches played}
#'   \item{starts}{Number of matches in which player started the game}
#'   \item{min}{Total minutes played in the season}
#'   \item{xGp90}{Expected goals per ninety minutes}
#'   \item{xAp90}{Expected assists per ninety minutes}
#'   \item{xGxAp90}{Expected goals plus assists per ninety minutes}
#'   \item{npxGp90}{Expected goals minus penalty goals per ninety minutes}
#'   \item{npxGxAp90}{Expected goals plus assists minus penalty goals per ninety minutes}
#' }
#' @source \url{https://fbref.com/en/comps/182/stats/NWSL-Stats}
"nwsl_player_stats"

#' 2024-2025 English Premier League Player Statistics
#'
#' A dataset containing individual player statistics for the English Premier League's 2024 - 2025 season
#'
#' @format A data frame with 574 rows and 38 variables:
#' \describe{
#'   \item{season_end_year}{Calendar year when season ended}
#'   \item{squad}{Player team}
#'   \item{comp}{League (Premier League)}
#'   \item{player}{Player name}
#'   \item{nation}{Player home country}
#'   \item{pos}{Player position}
#'   \item{age}{Age of player}
#'   \item{born}{Birth year of player}
#'   \item{mp}{Matches played}
#'   \item{starts}{Number of matches in which player started the game}
#'   \item{min}{Total minutes played in the season}
#'   \item{min_p90}{Total minutes played in the season per ninety minutes}
#'   \item{goals}{Goals scored by player}
#'   \item{assists}{Assists by player}
#'   \item{goals_assists}{Goals scored plus assists by player}
#'   \item{non_pen_goals}{Non-penalty goals scored by player}
#'   \item{pen_goals}{Penalty kick goals scored by player}
#'   \item{pen_att}{Penalty kick attempts by player}
#'   \item{yellow_cards}{Yellow cards earned by player}
#'   \item{red_cards}{Red cards earned by player}
#'   \item{xG}{Expected goals}
#'   \item{non_pen_xG}{Non-penalty kick expected goals}
#'   \item{xA}{Expected assists}
#'   \item{non_pen_xGxA}{Non-penalty kick expected goals and assists}
#'   \item{prg_carry}{Progressive carries}
#'   \item{prg_pass}{Progressive passes}
#'   \item{prg_reception}{Progressive passes received}
#'   \item{goals_p90}{Goals per ninety minutes}
#'   \item{assists_p90}{Assists per ninety minutes}
#'   \item{goals_assists_p90}{Goals and assists per ninety minutes}
#'   \item{non_pen_goals_p90}{Non-penalty kick goals per ninety minutes}
#'   \item{non_pen_goals_assists_p90}{Non-penalty kick goals and assists per ninety minutes}
#'   \item{xG_p90}{Expected goals per ninety minutes}
#'   \item{xA_p90}{Expected assists per ninety minutes}
#'   \item{xG_xA_p90}{Expected goals plus assists per ninety minutes}
#'   \item{non_pen_xG_p90}{Expected goals minus penalty goals per ninety minutes}
#'   \item{non_pen_xG_xA_p90}{Expected goals plus assists minus penalty goals per ninety minutes}
#'   \item{url}{URL of player stats on fbref.com}
#' }
#'
#' @source From fbref.com via the worldfootballR package
"epl_player_stats_2025"

#' 2017-18 through 2021-22 English Premier League Tea, Statistics
#'
#' A dataset containing team statistics for the English Premier League
#'
#' @format A data frame with 100 rows and 29 variables:
#' \describe{
#'   \item{squad}{Team or club name}
#'   \item{season}{Season}
#'   \item{num_players}{Number of players used in the season}
#'   \item{age}{Age of players weighted by minutes played}
#'   \item{poss}{Possession as a percentage of passes attempted}
#'   \item{goals}{Goals scored by team}
#'   \item{assists}{Assists by team}
#'   \item{goals_assists}{Goals scored plus assists by team}
#'   \item{non_pen_goals}{Non-penalty goals scored by team}
#'   \item{pen_goals}{Penalty kick goals scored by team}
#'   \item{pen_att}{Penalty kick attempts by team}
#'   \item{yellow_cards}{Yellow cards earned by team}
#'   \item{red_cards}{Red cards earned by team}
#'   \item{xG}{Expected goals}
#'   \item{non_pen_xG}{Non-penalty kick expected goals}
#'   \item{xA}{Expected assists}
#'   \item{non_pen_xGxA}{Non-penalty kick expected goals and assists}
#'   \item{prg_carry}{Progressive carries}
#'   \item{prg_pass}{Progressive passes}
#'   \item{goals_p90}{Goals per ninety minutes}
#'   \item{assists_p90}{Assists per ninety minutes}
#'   \item{goals_assists_p90}{Goals and assists per ninety minutes}
#'   \item{non_pen_goals_p90}{Non-penalty kick goals per ninety minutes}
#'   \item{non_pen_goals_assists_p90}{Non-penalty kick goals and assists per ninety minutes}
#'   \item{xG_p90}{Expected goals per ninety minutes}
#'   \item{xA_p90}{Expected assists per ninety minutes}
#'   \item{xG_xA_p90}{Expected goals plus assists per ninety minutes}
#'   \item{non_pen_xG_p90}{Expected goals minus penalty goals per ninety minutes}
#'   \item{non_pen_xG_xA_p90}{Expected goals plus assists minus penalty goals per ninety minutes}
#' }
#'
#' @source \url{https://fbref.com/en/comps/9/2021-2022/stats/2021-2022-Premier-League-Stats}
"epl_team_stats"

#'  NHL Skater Statistics from Hockey Reference
#'
#' A dataset containing NHL Skater Statistics
#'
#' @format A data frame with 12375 rows and 49 variables:
#' \describe{
#'   \item{player}{Name}
#'   \item{age}{Age}
#'   \item{tm}{Team}
#'   \item{pos}{Position}
#'   \item{gp}{Games played}
#'   \item{g}{Goals}
#'   \item{a}{Assists}
#'   \item{pts}{Goals plus Assists (Points)}
#'   \item{x}{Plus Minus}
#'   \item{pim}{Penalties in minutes}
#'   \item{ps}{Point shares}
#'   \item{ev}{Even strength goals}
#'   \item{pp}{Power play goals}
#'   \item{sh}{Short handed goals}
#'   \item{gw}{Game winning goals}
#'   \item{eva}{Even strength assists}
#'   \item{ppa}{Power play assists}
#'   \item{sha}{Short handed assists}
#'   \item{s}{Shots on goal}
#'   \item{s_percent}{Shooting percentage}
#'   \item{toi}{Time on ice (minutes)}
#'   \item{atoi}{Average time on ice}
#'   \item{blk}{Blocks}
#'   \item{hit}{Hits}
#'   \item{fow}{Face offs won}
#'   \item{fol}{Face offs lost}
#'   \item{fo_percent}{Face off win percentage}
#'   \item{cf}{Corsi for }
#'   \item{ca}{Corsi against}
#'   \item{cf_percent}{Corsi for percent}
#'   \item{cf_percent_rel}{On-ice Corsi for percent minus off-ice Corsi for percent}
#'   \item{ff}{Fenwick for}
#'   \item{fa}{Fenwick against}
#'   \item{ff_percent}{Fenwick for percent}
#'   \item{ff_percent_rel}{On-ice Fenwick for percent minus off-ice Fenwick for percent}
#'   \item{oi_sh_percent}{Team on-ice shooting percentage}
#'   \item{oi_sv_percent}{Team on-ice save percentage}
#'   \item{pdo}{PDO}
#'   \item{o_zs_percent}{Offensive zone start percentage}
#'   \item{d_zs_percent}{Defensive zone start percentage}
#'   \item{toi_60}{Time on ice per 60 minutes}
#'   \item{toi_ev}{Time on ice per 60 minutes at even strength}
#'   \item{tk}{Takeaways}
#'   \item{gv}{Giveaways}
#'   \item{s_att}{Total shot attempts in all situations}
#'   \item{thru_percent}{Percentage of shots taken that go on net}
#'   \item{season}{Season}
#'   \item{e}{Expected plus minus}
#' }
#' @source \url{https://www.nhl.com/stats/}
"nhl_data_hockey_reference"

#' 2015/16 - 2024/25 Shot Data for the NBA's Denver Nuggets
#'
#' A dataset containing seven seasons of Denver Nuggets shot data from NBA.com
#'
#' @format A data frame with 70488 rows and 16 variables:
#' \describe{
#'   \item{seasonId}{Season in which the game was played (YYYY-YY)}
#'   \item{gameId}{Game ID on nba.com}
#'   \item{namePlayer}{Player name}
#'   \item{nameTeam}{Full team name}
#'   \item{shotType}{Two or three point shot}
#'   \item{zoneBasic}{Description of area on court where shot was taken}
#'   \item{shotZoneArea}{More descriptive shot zone}
#'   \item{shotZoneRange}{Distance of shot in categories}
#'   \item{locationX}{X cordinate where shot was taken}
#'   \item{locationY}{Y cordinate where shot was taken}
#'   \item{shotMadeFlag}{character variable for make/miss (1/0) of shot}
#'   \item{htm}{Home Team abbreviation}
#'   \item{vtm}{Visiting Team abbreviation}
#'   \item{isHomeGame}{logical variable for home game (T/F)}
#'   \item{opponentName}{Team name of opponent}
#'   \item{isShotMade}{logical variable for make/miss (T/F) of shot}
#' }
#' @source \url{http://stats.nba.com}
"nba_nuggets_shots_2025"

#' Draftkings Showdown Game in NHL (Boston Bruins at Buffalo Sabres, April 21, 2026)
#'
#' A dataset containing the Draftkings salary information for Game 2 of the
#'  2026 NHL Playoffs between the Boston Bruins and Buffalo Sabres (round 1).
#'
#' @format A data frame with 128 rows and 9 variables:
#' \describe{
#'   \item{position}{real-life roster position of the player}
#'   \item{name_id}{player name and Draftkings ID}
#'   \item{name}{player name}
#'   \item{id}{Draftkings player ID}
#'   \item{roster_position}{Draftkings roster position}
#'   \item{salary}{player salary}
#'   \item{game_info}{game information for the players}
#'   \item{team_abbrev}{player team as an abbreviation}
#'   \item{avg_points_per_game}{player average Draftkings points per game}
#' }
#' @source Draftkings Contest Page
"dk_bos_buf"

#' 2021 NBA Four Factors (Team) for the 2020-21 Season
#'
#' A dataset containing the NBA Four Factor table on nba.com
#'
#' @format A data frame with 2160 rows and 11 variables:
#' \describe{
#'   \item{idGame}{Game ID on nba.com}
#'   \item{slugTeam}{Team abbreviation}
#'   \item{idTeam}{Team ID on nba.com}
#'   \item{pctEFGOpponent}{Effective field goal percentage of opponent}
#'   \item{pctTOVOpponent}{Turnover percentage of opponent}
#'   \item{pctOREBOpponent}{Offensive rebound percentage of opponent}
#'   \item{teamName}{Team Mascot}
#'   \item{cityTeam}{City of slugTeam}
#'   \item{minExact}{Total minutes played}
#'   \item{rateFTA}{Free throw rate of slugTeam}
#'   \item{rateFTAOpponent}{Free throw rate of opponent}
#' }
#' @source \url{http://asbcllc.com/nbastatR/reference/box_scores.html}
"nba_ff_team_2021"

#' 2022-3 NHL Team Statistics
#'
#' A dataset containing the NHL Statistics
#'
#' @format A data frame with 32 rows and 35 variables:
#' \describe{
#'   \item{stat_games_played}{Games played}
#'   \item{stat_wins}{Wins}
#'   \item{stat_losses}{Losses}
#'   \item{stat_ot}{Overtimes}
#'   \item{stat_pts}{Points}
#'   \item{stat_pt_pctg}{Point Percentage}
#'   \item{stat_goals_per_game}{Goals per game}
#'   \item{stat_goals_against_per_game}{Goals against per game}
#'   \item{stat_ev_gga_ratio}{Even strength gga ratio}
#'   \item{stat_power_play_percentage}{Power play percentage}
#'   \item{stat_power_play_goals}{Power play goals}
#'   \item{stat_power_play_goals_against}{Power play goals against}
#'   \item{stat_power_play_opportunities}{Power play opportunities}
#'   \item{stat_penalty_kill_percentage}{Penalty kill percentage}
#'   \item{stat_shots_per_game}{Shots per game}
#'   \item{stat_shots_allowed}{Shots allowed}
#'   \item{stat_win_score_first}{Wins when scoring first}
#'   \item{stat_win_opp_score_first}{Wins when opponent scores first}
#'   \item{stat_win_lead_first_per}{Wins when leading after first period}
#'   \item{stat_win_lead_second_per}{Wins when leading after second period}
#'   \item{stat_win_outshoot_opp}{Wins when outshooting opponent}
#'   \item{stat_win_outshot_by_opp}{Wins when outshot by opponent}
#'   \item{stat_face_offs_taken}{Face-offs taken}
#'   \item{stat_face_offs_won}{Face-offs won}
#'   \item{stat_face_offs_lost}{Face-offs lost}
#'   \item{stat_face_off_win_percentage}{Face-off win percentage}
#'   \item{stat_shooting_pctg}{Shooting percentage}
#'   \item{stat_save_pctg}{Save percentage}
#'   \item{stat_penalty_kill_opportunities}{Penalty kill opportunities}
#'   \item{stat_save_pct_rank}{Save percentage rank}
#'   \item{stat_shooting_pct_rank}{Shooting percentage rank}
#'   \item{team_id}{Team ID}
#'   \item{team_name}{Team name}
#'   \item{team_link}{Team link}
#'   \item{season}{Season}
#' }
#' @source \url{https://www.nhl.com/stats/}
"nhl_team_stats_2022"

#' NBA Advanced Statistics (Team) for the 2022-23 Season
#'
#' A dataset containing the NBA Four Factor table on nba.com
#'
#' @format A data frame with 2460 rows and 29 variables:
#' \describe{
#'   \item{game_id}{Game ID on nba.com}
#'   \item{team_id}{Team ID on nba.com}
#'   \item{team_name}{Team name}
#'   \item{team_abbreviation}{Team abbreviation}
#'   \item{team_city}{Team city}
#'   \item{min}{Total minutes in the game}
#'   \item{e_off_rating}{offensive rating (effective ?)}
#'   \item{off_rating}{offensive rating}
#'   \item{e_def_rating}{defensive rating (effective ?)}
#'   \item{def_rating}{defensive rating}
#'   \item{e_net_rating}{net rating (effective ?)}
#'   \item{net_rating}{net rating}
#'   \item{ast_pct}{Assist percentage}
#'   \item{ast_tov}{Assists to turnover ratio}
#'   \item{ast_ratio}{Assist ratio}
#'   \item{oreb_pct}{Offensive rebound percentage}
#'   \item{dreb_pct}{Defensive rebound percentage}
#'   \item{reb_pct}{Total rebound percentage}
#'   \item{e_tm_tov_pct}{Turnover percentage (effective?)}
#'   \item{tm_tov_pct}{Turnover percentage}
#'   \item{efg_pct}{Effective field goal percentage}
#'   \item{ts_pct}{True Shooting percentage}
#'   \item{usg_pct}{Usage percentage}
#'   \item{e_usg_pct}{Usage percentage (effective?)}
#'   \item{e_pace}{pace (effective ?)}
#'   \item{pace}{pace}
#'   \item{pace_per40}{pace per forty minutes}
#'   \item{poss}{team possessions in game}
#'   \item{pie}{Player impact estimate}
#' }
#' @source \url{http://asbcllc.com/nbastatR/reference/box_scores.html}
"nba_adv_team_2023"

#' 2014/5 - 2022/23 Shot Data for the NBA's Denver Nuggets
#'
#' A dataset containing seven seasons of Denver Nuggets shot data from NBA.com
#'
#' @format A data frame with 62196 rows and 27 variables:
#' \describe{
#'   \item{yearSeason}{Season in which the game was played (YYYY)}
#'   \item{slugSeason}{Season in which the game was played (YYYY-YY)}
#'   \item{idTeam}{Team ID on nba.com}
#'   \item{idPlayer}{Player ID on nba.com}
#'   \item{typeGrid}{A string showing grid type}
#'   \item{namePlayer}{Player name}
#'   \item{nameTeam}{Full team name}
#'   \item{typeEvent}{Made or Missed Shot}
#'   \item{typeAction}{Type of shot, e.g. Jump Shot}
#'   \item{typeShot}{Two or three point shot}
#'   \item{dateGame}{Date in YYYY-MM-DD}
#'   \item{slugTeamHome}{Home Team abbreviation}
#'   \item{slugTeamAway}{Away Team abbreviation}
#'   \item{idGame}{Game ID on nba.com}
#'   \item{idEvent}{Event ID within the game on nba.com}
#'   \item{numberPeriod}{Period in game in which the shot was taken}
#'   \item{minutesRemaining}{Minutes remaining in the period in which the shot was taken}
#'   \item{zoneBasic}{Description of area on court where shot was taken}
#'   \item{nameZone}{Name of the zone}
#'   \item{slugZone}{Abbreviation of shot zone}
#'   \item{zoneRange}{Distance of shot in categories}
#'   \item{locationX}{X cordinate where shot was taken}
#'   \item{locationY}{Y cordinate where shot was taken}
#'   \item{secondsRemaining}{Seconds remainin when shot was taken}
#'   \item{distanceShot}{Distance of the shot in feet}
#'   \item{isShotAttempted}{Logical for shot taken}
#'   \item{isShotMade}{Logical for make/miss of shot}
#' }
#' @source \url{http://asbcllc.com/nbastatR/reference/teams_shots.html}
"nba_nuggets_shots"

#' Draftkings Showdown Game in NHL (Edmonton Oilers versus Colorado Avalanche)
#'
#' A dataset containing the Draftkings salary information for Game 1 of the
#'  2022 NHL Playoffs between the Edmonton Oilers versus Colorado Avalanche.
#'
#' @format A data frame with 252 rows and 9 variables:
#' \describe{
#'   \item{position}{real-life roster position of the player}
#'   \item{name_id}{player name and Draftkings ID}
#'   \item{name}{player name}
#'   \item{id}{Draftkings player ID}
#'   \item{roster_position}{Draftkings roster position}
#'   \item{salary}{player salary}
#'   \item{game_info}{game information for the players}
#'   \item{team_abbrev}{player team as an abbreviation}
#'   \item{avg_points_per_game}{player average Draftkings points per game}
#' }
#' @source Draftkings Contest Page
"dk_edm_col"

#' 2025 WNBA Player Shots
#'
#' A dataset containing Breanna Stewart and A'ja Wilson's WNBA shots in the 2025 season
#'
#' @format A data frame with 3297 rows and 3 variables:
#' \describe{
#'   \item{athlete_display_name}{Player name}
#'.  \item{coordinate_x}{X Coordinate of Shot}
#'.  \item{coordinate_y}{Y Coordinate of Shot}
#' }
#' @source \url{https://wehoop.sportsdataverse.org}
"wnba_player_shots_2025"

#' PGA Tournament Data
#'
#' A dataset containing PGA Tournament Data from 2022 season
#'
#' @format A data frame with 3676 rows and 34 variables:
#' \describe{
#'   \item{Player_initial_last}{initial of first name and complete last name of player}
#'   \item{tournament.id}{tournament ID}
#'   \item{player.id}{plyaer ID}
#'   \item{hole_par}{par across all holes played by the player}
#'   \item{strokes}{strokes taken on all holes played by the player}
#'   \item{hole_DKP}{Draftkings points on holes}
#'   \item{hole_FDP}{Fanduel points on the holes}
#'   \item{hole_SDP}{Showdown points on the holes}
#'   \item{streak_DKP}{Draftkings points on streaks}
#'   \item{streak_FDP}{Fanduel points on streaks}
#'   \item{streak_SDP}{Showdown points on streaks}
#'   \item{n_rounds}{number of rounds played}
#'   \item{made_cut}{player made the cut or not}
#'   \item{pos}{finishing position of player}
#'   \item{finish_DKP}{Draftkings points on the finishing position}
#'   \item{finish_FDP}{Fanduel points on the finishing position}
#'   \item{finish_SDP}{Showdown points on the finishing position}
#'   \item{total_DKP}{total Draftkings points for the tournament}
#'   \item{total_FDP}{total Fanduel points for the tournament}
#'   \item{total_SDP}{total Showdown points for the tournament}
#'   \item{player}{player full name}
#'   \item{tournament.name}{tournament full name}
#'   \item{course}{course name}
#'   \item{date}{data of tournament}
#'   \item{purse}{total prize money (in millions)}
#'   \item{season}{year of season}
#'   \item{no_cut}{Not sure}
#'   \item{Finish}{finishing position}
#'   \item{sg_putt}{strokes gained from putting}
#'   \item{sg_arg}{strokes gained around the green}
#'   \item{sg_app}{strokes gained on approach shots}
#'   \item{sg_ott}{strokes gained off the tee}
#'   \item{sg_t2g}{strokes gained tee to green}
#'   \item{sg_total}{total strokes gained}
#' }
#' @source Courtesy of Matt Courchene of Datagolf.com
"pga_tournaments"

#' NBA Four Factors (Team) for the 2023-24 Season
#'
#' A dataset containing the NBA Four Factor table on nba.com
#'
#' @format A data frame with 2460 rows and 14 variables:
#' \describe{
#'   \item{game_id}{Game ID on nba.com}
#'   \item{team_id}{Team ID on nba.com}
#'   \item{team_name}{Team name on nba.com}
#'   \item{team_abbreviation}{Team abbreviation on nba.com}
#'   \item{team_city}{Team city}
#'   \item{min}{Minutes in the game}
#'   \item{efg_pct}{Effective field goal percentage}
#'   \item{fta_rate}{Free throw rate of team}
#'   \item{tm_tov_pct}{Turnover percentage of opponent}
#'   \item{oreb_pct}{Offensive rebound percentage of opponent}
#'   \item{opp_efg_pct}{Effective field goal percentage of opponent}
#'   \item{opp_fta_rate}{Free throw rate of opponent}
#'   \item{opp_tov_pct}{Turnover percentage of opponent}
#'   \item{opp_oreb_pct}{Offensive rebound percentage of opponent}
#' }
#' @source \url{http://asbcllc.com/nbastatR/reference/box_scores.html}
"nba_ff_team_2024"

---
name: Improvement
about: Suggest an improvement to existing functionality
title: ''
labels: improvement
assignees: ''

---

**Describe the improvement you would like to see**
A clear and concise description of the improvement proposal.

**How will this change existing functionality?**
A clear and concise description on how this will affect current functionality.

**How will this improvement affect the current Threat Model?**
Leave blank for maintainers to fill out if you are uncertain about this.

---
name: Feature
about: Suggest a new feature for this project
title: ''
labels: feature
assignees: ''

---

**Describe the new feature you would like to see**
A clear and concise description of the feature.

**Describe the solution you'd like**
If you have an idea of how to implement the feature please describe it here.

**How will this feature affect the current Threat Model?**
Leave blank for maintainers to fill out if you are uncertain about this.

## Ready for review checklist:
- [ ] A self-review has been performed
- [ ] All commits run individually
- [ ] Temporary changes have been removed, like logging, TODO, etc.
- [ ] The PR has been tested locally
- [ ] A test has been written
  - [ ] This change doesn't need a new test
- [ ] Relevant issues are linked
- [ ] Remaining work is documented in issues
  - [ ] There is no remaining work from this PR that requires new issues
- [ ] The changes do not introduce dead code as unused imports, functions etc.

## SECURITY.md template for isar (public repository)

If you discover a security vulnerability in this project, please follow these steps to responsibly disclose it:

1. **Do not** create a public GitHub issue for the vulnerability.
2. Follow our guideline for Responsible Disclosure Policy at [https://www.equinor.com/about-us/csirt](https://www.equinor.com/about-us/csirt) to report the issue

The following information will help us triage your report more quickly:

- Type of issue (e.g. buffer overflow, SQL injection, cross-site scripting, etc.)
- Full paths of source file(s) related to the manifestation of the issue
- The location of the affected source code (tag/branch/commit or direct URL)
- Any special configuration required to reproduce the issue
- Step-by-step instructions to reproduce the issue
- Proof-of-concept or exploit code (if possible)
- Impact of the issue, including how an attacker might exploit the issue

We prefer all communications to be in English.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nwsl_player_stats_2024.R
\docType{data}
\name{nwsl_player_stats_2024}
\alias{nwsl_player_stats_2024}
\title{2024 NWSL Player Statistics}
\format{
A data frame with 376 rows and 18 variables:
\describe{
  \item{player}{Player name}
  \item{nation}{Player home country}
  \item{pos}{Player position}
  \item{squad}{Player team}
  \item{age}{Age of player}
  \item{mp}{Matches played}
  \item{starts}{Number of matches in which player started the game}
  \item{min}{Total minutes played in the season}
  \item{Gp90}{Goals per ninety minutes}
  \item{Ap90}{Assists per ninety minutes}
  \item{GAp90}{Goals plus assists per ninety minutes}
  \item{npGp90}{Goals minus penalty goals per ninety minutes}
  \item{npGAp90}{Goals plus assists minus penalty goals per ninety minutes}
  \item{xGp90}{Expected goals per ninety minutes}
  \item{xAp90}{Expected assists per ninety minutes}
  \item{xGxAp90}{Expected goals plus assists per ninety minutes}
  \item{npxGp90}{Expected goals minus penalty goals per ninety minutes}
  \item{npxGxAp90}{Expected goals plus assists minus penalty goals per ninety minutes}
}
}
\source{
\url{https://fbref.com/en/comps/182/stats/NWSL-Stats}
}
\usage{
nwsl_player_stats_2024
}
\description{
A dataset containing individual player statistics for the National Women's Soccer League
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nba_advanced_team_2021.R
\docType{data}
\name{nba_adv_team_2021}
\alias{nba_adv_team_2021}
\title{2021 NBA Advanced Statistics (Team) for the 2020-21 Season}
\format{
A data frame with 2160 rows and 29 variables:
\describe{
  \item{idGame}{Game ID on nba.com}
  \item{slugTeam}{Team abbreviation}
  \item{idTeam}{Team ID on nba.com}
  \item{pctAST}{Assist percentage}
  \item{pctOREB}{Offensive rebound percentage}
  \item{pctDREB}{Defensive rebound percentage}
  \item{pctTREB}{Total rebound percentage}
  \item{pctTOVE}{Turnover percentage (one)}
  \item{pctTOVTeam}{Turnover percentage (two)}
  \item{pctEFG}{Effective field goal percentage}
  \item{pctTS}{True Shooting percentage}
  \item{pctUSG}{Usage metric}
  \item{pctUSGE}{Usage percentage}
  \item{teamName}{Team Mascot}
  \item{cityTeam}{City of slugTeam}
  \item{minExact}{Total minutes played}
  \item{ortgE}{offensive rating (effective ?)}
  \item{ortg}{offensive rating}
  \item{drtgE}{defensive rating (effective ?)}
  \item{drtg}{defensive rating}
  \item{netrtgE}{net rating (effective ?)}
  \item{netrtg}{net rating}
  \item{ratioASTtoTOV}{Assists to turnover ratio}
  \item{ratioAST}{Assist ratio}
  \item{paceE}{pace (effective ?)}
  \item{pace}{pace}
  \item{pacePer40PACE_PER40}{pace per forty minutes}
  \item{possessions}{team possessions in game}
  \item{ratioPIE}{Player impact estimate}
}
}
\source{
\url{http://asbcllc.com/nbastatR/reference/box_scores.html}
}
\usage{
nba_adv_team_2021
}
\description{
A dataset containing the NBA Four Factor table on nba.com
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nba_games_2024.R
\docType{data}
\name{nba_games_2024}
\alias{nba_games_2024}
\title{NBA Game Logs for the 2023-24 Season}
\format{
A data frame with 2460 rows and 29 variables:
\describe{
  \item{season_id}{Season in which the game was played (YYYY)}
  \item{team_id}{Team ID on nba.com}
  \item{team_abbreviation}{Team abbreviation on nba.com}
  \item{team_name}{Team name on nba.com}
  \item{game_id}{Game ID on nba.com}
  \item{game_date}{Date in YYYY-MM-DD}
  \item{matchup}{Team One vs. Team Two}
  \item{wl}{Win or Loss}
  \item{min}{Minutes in the game}
  \item{fgm}{Team Field goals made}
  \item{fga}{Team Field goal attempts}
  \item{fg_pct}{Team field goal percentage}
  \item{fg3m}{Team three point field goals made}
  \item{fg3a}{Team three point field goal attempts}
  \item{fg3_pct}{Team three point field goal percentage}
  \item{ftm}{Team free throws made}
  \item{fta}{Team free throw attempts}
  \item{ft_pct}{Team free throw percentage}
  \item{oreb}{Team offensive rebounds}
  \item{dreb}{Team defensive rebounds}
  \item{reb}{Team total rebounds}
  \item{ast}{Team total assists}
  \item{stl}{Team total steals}
  \item{blk}{Team total blocks}
  \item{tov}{Team total turnovers}
  \item{pf}{Team total personal fouls}
  \item{pts}{Team total points scored}
  \item{plus_minus}{Margin of game as Team score minus Opponent score}
  \item{video_available}{Logical if game video exists}
}
}
\source{
\url{http://asbcllc.com/nbastatR/reference/game_logs.html}
}
\usage{
nba_games_2024
}
\description{
A dataset containing the NBA Games table on nba.com
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pga_tournamentss.R
\docType{data}
\name{pga_tournaments}
\alias{pga_tournaments}
\title{PGA Tournament Data}
\format{
A data frame with 3676 rows and 34 variables:
\describe{
  \item{Player_initial_last}{initial of first name and complete last name of player}
  \item{tournament.id}{tournament ID}
  \item{player.id}{plyaer ID}
  \item{hole_par}{par across all holes played by the player}
  \item{strokes}{strokes taken on all holes played by the player}
  \item{hole_DKP}{Draftkings points on holes}
  \item{hole_FDP}{Fanduel points on the holes}
  \item{hole_SDP}{Showdown points on the holes}
  \item{streak_DKP}{Draftkings points on streaks}
  \item{streak_FDP}{Fanduel points on streaks}
  \item{streak_SDP}{Showdown points on streaks}
  \item{n_rounds}{number of rounds played}
  \item{made_cut}{player made the cut or not}
  \item{pos}{finishing position of player}
  \item{finish_DKP}{Draftkings points on the finishing position}
  \item{finish_FDP}{Fanduel points on the finishing position}
  \item{finish_SDP}{Showdown points on the finishing position}
  \item{total_DKP}{total Draftkings points for the tournament}
  \item{total_FDP}{total Fanduel points for the tournament}
  \item{total_SDP}{total Showdown points for the tournament}
  \item{player}{player full name}
  \item{tournament.name}{tournament full name}
  \item{course}{course name}
  \item{date}{data of tournament}
  \item{purse}{total prize money (in millions)}
  \item{season}{year of season}
  \item{no_cut}{Not sure}
  \item{Finish}{finishing position}
  \item{sg_putt}{strokes gained from putting}
  \item{sg_arg}{strokes gained around the green}
  \item{sg_app}{strokes gained on approach shots}
  \item{sg_ott}{strokes gained off the tee}
  \item{sg_t2g}{strokes gained tee to green}
  \item{sg_total}{total strokes gained}
}
}
\source{
Courtesy of Matt Courchene of Datagolf.com
}
\usage{
pga_tournaments
}
\description{
A dataset containing PGA Tournament Data from 2022 season
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nba_four_factors_team_2021.R
\docType{data}
\name{nba_ff_team_2021}
\alias{nba_ff_team_2021}
\title{2021 NBA Four Factors (Team) for the 2020-21 Season}
\format{
A data frame with 2160 rows and 11 variables:
\describe{
  \item{idGame}{Game ID on nba.com}
  \item{slugTeam}{Team abbreviation}
  \item{idTeam}{Team ID on nba.com}
  \item{pctEFGOpponent}{Effective field goal percentage of opponent}
  \item{pctTOVOpponent}{Turnover percentage of opponent}
  \item{pctOREBOpponent}{Offensive rebound percentage of opponent}
  \item{teamName}{Team Mascot}
  \item{cityTeam}{City of slugTeam}
  \item{minExact}{Total minutes played}
  \item{rateFTA}{Free throw rate of slugTeam}
  \item{rateFTAOpponent}{Free throw rate of opponent}
}
}
\source{
\url{http://asbcllc.com/nbastatR/reference/box_scores.html}
}
\usage{
nba_ff_team_2021
}
\description{
A dataset containing the NBA Four Factor table on nba.com
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nhl_team_stats_2022.R
\docType{data}
\name{nhl_team_stats_2022}
\alias{nhl_team_stats_2022}
\title{2022-3 NHL Team Statistics}
\format{
A data frame with 32 rows and 35 variables:
\describe{
  \item{stat_games_played}{Games played}
  \item{stat_wins}{Wins}
  \item{stat_losses}{Losses}
  \item{stat_ot}{Overtimes}
  \item{stat_pts}{Points}
  \item{stat_pt_pctg}{Point Percentage}
  \item{stat_goals_per_game}{Goals per game}
  \item{stat_goals_against_per_game}{Goals against per game}
  \item{stat_ev_gga_ratio}{Even strength gga ratio}
  \item{stat_power_play_percentage}{Power play percentage}
  \item{stat_power_play_goals}{Power play goals}
  \item{stat_power_play_goals_against}{Power play goals against}
  \item{stat_power_play_opportunities}{Power play opportunities}
  \item{stat_penalty_kill_percentage}{Penalty kill percentage}
  \item{stat_shots_per_game}{Shots per game}
  \item{stat_shots_allowed}{Shots allowed}
  \item{stat_win_score_first}{Wins when scoring first}
  \item{stat_win_opp_score_first}{Wins when opponent scores first}
  \item{stat_win_lead_first_per}{Wins when leading after first period}
  \item{stat_win_lead_second_per}{Wins when leading after second period}
  \item{stat_win_outshoot_opp}{Wins when outshooting opponent}
  \item{stat_win_outshot_by_opp}{Wins when outshot by opponent}
  \item{stat_face_offs_taken}{Face-offs taken}
  \item{stat_face_offs_won}{Face-offs won}
  \item{stat_face_offs_lost}{Face-offs lost}
  \item{stat_face_off_win_percentage}{Face-off win percentage}
  \item{stat_shooting_pctg}{Shooting percentage}
  \item{stat_save_pctg}{Save percentage}
  \item{stat_penalty_kill_opportunities}{Penalty kill opportunities}
  \item{stat_save_pct_rank}{Save percentage rank}
  \item{stat_shooting_pct_rank}{Shooting percentage rank}
  \item{team_id}{Team ID}
  \item{team_name}{Team name}
  \item{team_link}{Team link}
  \item{season}{Season}
}
}
\source{
\url{https://www.nhl.com/stats/}
}
\usage{
nhl_team_stats_2022
}
\description{
A dataset containing the NHL Statistics
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/avs_roster_2022.R
\docType{data}
\name{avs_roster_2022}
\alias{avs_roster_2022}
\title{2022-23 NHL Colorado Avalanche Roster (from NHL's API)}
\format{
A data frame with 24 rows and 8 variables:
\describe{
  \item{jersey_number}{player jersey number}
  \item{person_id}{player ID}
  \item{person_full_name}{player full name}
  \item{person_link}{API link to player data}
  \item{position_code}{position abbreviation}
  \item{position_name}{position name}
  \item{position_type}{position type}
  \item{position_abbreviation}{another position abbreviation}
}
}
\source{
\url{https://www.nhl.com/stats/}
}
\usage{
avs_roster_2022
}
\description{
A dataset containing the NHL's Avalanche Roster
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nba_advanced_team_2024.R
\docType{data}
\name{nba_adv_team_2024}
\alias{nba_adv_team_2024}
\title{NBA Advanced Statistics (Team) for the 2023-24 Season}
\format{
A data frame with 2460 rows and 29 variables:
\describe{
  \item{game_id}{Game ID on nba.com}
  \item{team_id}{Team ID on nba.com}
  \item{team_name}{Team name}
  \item{team_abbreviation}{Team abbreviation}
  \item{team_city}{Team city}
  \item{min}{Total minutes in the game}
  \item{e_off_rating}{offensive rating (effective ?)}
  \item{off_rating}{offensive rating}
  \item{e_def_rating}{defensive rating (effective ?)}
  \item{def_rating}{defensive rating}
  \item{e_net_rating}{net rating (effective ?)}
  \item{net_rating}{net rating}
  \item{ast_pct}{Assist percentage}
  \item{ast_tov}{Assists to turnover ratio}
  \item{ast_ratio}{Assist ratio}
  \item{oreb_pct}{Offensive rebound percentage}
  \item{dreb_pct}{Defensive rebound percentage}
  \item{reb_pct}{Total rebound percentage}
  \item{e_tm_tov_pct}{Turnover percentage (effective?)}
  \item{tm_tov_pct}{Turnover percentage}
  \item{efg_pct}{Effective field goal percentage}
  \item{ts_pct}{True Shooting percentage}
  \item{usg_pct}{Usage percentage}
  \item{e_usg_pct}{Usage percentage (effective?)}
  \item{e_pace}{pace (effective ?)}
  \item{pace}{pace}
  \item{pace_per40}{pace per forty minutes}
  \item{poss}{team possessions in game}
  \item{pie}{Player impact estimate}
}
}
\source{
\url{http://asbcllc.com/nbastatR/reference/box_scores.html}
}
\usage{
nba_adv_team_2024
}
\description{
A dataset containing the NBA Four Factor table on nba.com
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/draftkings-bos-buf.R
\docType{data}
\name{dk_bos_buf}
\alias{dk_bos_buf}
\title{Draftkings Showdown Game in NHL (Boston Bruins at Buffalo Sabres, April 21, 2026)}
\format{
A data frame with 128 rows and 9 variables:
\describe{
  \item{position}{real-life roster position of the player}
  \item{name_id}{player name and Draftkings ID}
  \item{name}{player name}
  \item{id}{Draftkings player ID}
  \item{roster_position}{Draftkings roster position}
  \item{salary}{player salary}
  \item{game_info}{game information for the players}
  \item{team_abbrev}{player team as an abbreviation}
  \item{avg_points_per_game}{player average Draftkings points per game}
}
}
\source{
Draftkings Contest Page
}
\usage{
dk_bos_buf
}
\description{
A dataset containing the Draftkings salary information for Game 2 of the
 2026 NHL Playoffs between the Boston Bruins and Buffalo Sabres (round 1).
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/masters.R
\docType{data}
\name{masters}
\alias{masters}
\title{2019 Masters Tournament Scores}
\format{
A data frame with 87 rows and 9 variables:
\describe{
  \item{pos}{finishing position for a player}
  \item{player_name}{name of the golfer}
  \item{nationality}{nationality of the golfer}
  \item{score}{final score relative to par}
  \item{round_1}{number of strokes from the first round}
  \item{round_2}{number of strokes from the second round}
  \item{round_3}{number of strokes from the third round}
  \item{round_4}{number of strokes from the fourth round}
  \item{total}{total strokes from all rounds}
}
}
\source{
\url{https://www.sportingnews.com/us/golf/news/masters-leaderboard-2019-live-scores-results-sunday/n1j77sci339r1f60hm3e1ei17}
}
\usage{
masters
}
\description{
A dataset containing the scores from the 2019 Masters Golf Tournament.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nba_nuggets_shots_2025.R
\docType{data}
\name{nba_nuggets_shots_2025}
\alias{nba_nuggets_shots_2025}
\title{2015/16 - 2024/25 Shot Data for the NBA's Denver Nuggets}
\format{
A data frame with 70488 rows and 16 variables:
\describe{
  \item{seasonId}{Season in which the game was played (YYYY-YY)}
  \item{gameId}{Game ID on nba.com}
  \item{namePlayer}{Player name}
  \item{nameTeam}{Full team name}
  \item{shotType}{Two or three point shot}
  \item{zoneBasic}{Description of area on court where shot was taken}
  \item{shotZoneArea}{More descriptive shot zone}
  \item{shotZoneRange}{Distance of shot in categories}
  \item{locationX}{X cordinate where shot was taken}
  \item{locationY}{Y cordinate where shot was taken}
  \item{shotMadeFlag}{character variable for make/miss (1/0) of shot}
  \item{htm}{Home Team abbreviation}
  \item{vtm}{Visiting Team abbreviation}
  \item{isHomeGame}{logical variable for home game (T/F)}
  \item{opponentName}{Team name of opponent}
  \item{isShotMade}{logical variable for make/miss (T/F) of shot}
}
}
\source{
\url{http://stats.nba.com}
}
\usage{
nba_nuggets_shots_2025
}
\description{
A dataset containing seven seasons of Denver Nuggets shot data from NBA.com
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/epl_player_stats_2023.R
\docType{data}
\name{epl_player_stats_2023}
\alias{epl_player_stats_2023}
\title{2022-2023 English Premier League Player Statistics}
\format{
A data frame with 569 rows and 38 variables:
\describe{
  \item{season_end_year}{Calendar year when season ended}
  \item{squad}{Player team}
  \item{comp}{League (Premier League)}
  \item{player}{Player name}
  \item{nation}{Player home country}
  \item{pos}{Player position}
  \item{age}{Age of player}
  \item{born}{Birth year of player}
  \item{mp}{Matches played}
  \item{starts}{Number of matches in which player started the game}
  \item{min}{Total minutes played in the season}
  \item{min_p90}{Total minutes played in the season per ninety minutes}
  \item{goals}{Goals scored by player}
  \item{assists}{Assists by player}
  \item{goals_assists}{Goals scored plus assists by player}
  \item{non_pen_goals}{Non-penalty goals scored by player}
  \item{pen_goals}{Penalty kick goals scored by player}
  \item{pen_att}{Penalty kick attempts by player}
  \item{yellow_cards}{Yellow cards earned by player}
  \item{red_cards}{Red cards earned by player}
  \item{xG}{Expected goals}
  \item{non_pen_xG}{Non-penalty kick expected goals}
  \item{xA}{Expected assists}
  \item{non_pen_xGxA}{Non-penalty kick expected goals and assists}
  \item{prg_carry}{Progressive carries}
  \item{prg_pass}{Progressive passes}
  \item{prg_reception}{Progressive passes received}
  \item{goals_p90}{Goals per ninety minutes}
  \item{assists_p90}{Assists per ninety minutes}
  \item{goals_assists_p90}{Goals and assists per ninety minutes}
  \item{non_pen_goals_p90}{Non-penalty kick goals per ninety minutes}
  \item{non_pen_goals_assists_p90}{Non-penalty kick goals and assists per ninety minutes}
  \item{xG_p90}{Expected goals per ninety minutes}
  \item{xA_p90}{Expected assists per ninety minutes}
  \item{xG_xA_p90}{Expected goals plus assists per ninety minutes}
  \item{non_pen_xG_p90}{Expected goals minus penalty goals per ninety minutes}
  \item{non_pen_xG_xA_p90}{Expected goals plus assists minus penalty goals per ninety minutes}
  \item{url}{URL of player stats on fbref.com}
}
}
\source{
From fbref.com via the worldfootballR package
}
\usage{
epl_player_stats_2023
}
\description{
A dataset containing individual player statistics for the English Premier League's 2022 - 2023 season
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/epl_gk_stats_2025.R
\docType{data}
\name{epl_gk_stats_2025}
\alias{epl_gk_stats_2025}
\title{2024-2025 English Premier League Goalkeeper Statistics}
\format{
A data frame with 44 rows and 35 variables:
\describe{
  \item{season_end_year}{Calendar year when season ended}
  \item{squad}{Player team}
  \item{comp}{League (Premier League)}
  \item{player}{Player name}
  \item{nation}{Player home country}
  \item{pos}{Player position}
  \item{age}{Age of player}
  \item{born}{Birth year of player}
  \item{min_p90}{Total minutes played in the season per ninety minutes}
  \item{goals}{Goals scored against player}
  \item{pk_allowed}{Penalty kick goals scored against player}
  \item{free_kick_goals}{Free kick goals scored against player}
  \item{corner_kick_goals}{Corner kick goals scored against player}
  \item{own_goals_against}{Own goals scored against player}
  \item{post_shot_xG}{Post-shot expected goals}
  \item{post_shot_xG_per_shot_on_target}{Post-shot expected goals per shot on target}
  \item{post_shot_xG_minus_goals}{Post-shot expected goals minus goals per shot on target}
  \item{post_shot_xG_minus_goals_p90}{Post-shot expected goals minus goals per shot on target per ninety minutes}
  \item{launch_completed}{Passes longer than 40 yards (launch) completed}
  \item{launch_attempt}{Passes longer than 40 yards attempted}
  \item{launch_completion_percent}{Passes longer than 40 yards (launch) completion percentage}
  \item{pass_attempt}{Passes attempted}
  \item{throw_attempt}{Throws attempted}
  \item{pass_launch_percent}{Percentage of passes launched}
  \item{avg_pass_len}{Average pass length}
  \item{goal_kick_attempt}{Goal kick attempts}
  \item{gk_launch_percent}{Percentage of goals kicks launched}
  \item{avg_gk_len}{Average goal kick length}
  \item{crosses_faced}{Number of crosses faced}
  \item{crosses_stopped}{Number of crosses stopped}
  \item{stop_percent}{Cross stop percentage}
  \item{def_actions_out_pen_area}{Defensive actions outside the penalty area}
  \item{def_actions_out_pen_area_p90}{Defensive actions outside the penalty area per ninety minutes}
  \item{avg_dist_def_actions}{Average distance from goal of defensive actions}
  \item{url}{URL of player stats on fbref.com}
}
}
\source{
From fbref.com via the worldfootballR package
}
\usage{
epl_gk_stats_2025
}
\description{
A dataset containing individual goalkeeper statistics for the English Premier League's 2024 - 2025 season
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nba_four_factors_team_2023.R
\docType{data}
\name{nba_ff_team_2023}
\alias{nba_ff_team_2023}
\title{NBA Four Factors (Team) for the 2022-23 Season}
\format{
A data frame with 2460 rows and 14 variables:
\describe{
  \item{game_id}{Game ID on nba.com}
  \item{team_id}{Team ID on nba.com}
  \item{team_name}{Team name on nba.com}
  \item{team_abbreviation}{Team abbreviation on nba.com}
  \item{team_city}{Team city}
  \item{min}{Minutes in the game}
  \item{efg_pct}{Effective field goal percentage}
  \item{fta_rate}{Free throw rate of team}
  \item{tm_tov_pct}{Turnover percentage of opponent}
  \item{oreb_pct}{Offensive rebound percentage of opponent}
  \item{opp_efg_pct}{Effective field goal percentage of opponent}
  \item{opp_fta_rate}{Free throw rate of opponent}
  \item{opp_tov_pct}{Turnover percentage of opponent}
  \item{opp_oreb_pct}{Offensive rebound percentage of opponent}
}
}
\source{
\url{http://asbcllc.com/nbastatR/reference/box_scores.html}
}
\usage{
nba_ff_team_2023
}
\description{
A dataset containing the NBA Four Factor table on nba.com
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ow_golf_rankings.R
\docType{data}
\name{ow_golf_rankings}
\alias{ow_golf_rankings}
\title{2022 Official World Golf Rankings}
\format{
A data frame with 300 rows and 2 variables:
\describe{
  \item{WGR_June_2022}{official golf world ranking}
  \item{Player_initial_last}{initial of first name and complete last name of player}
}
}
\source{
\url{https://www.owgr.com/archive/archive.sps?iType=1747}
}
\usage{
ow_golf_rankings
}
\description{
A dataset containing the Official World Golf Rankings in June 2022
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nhl_data_hockey_reference.R
\docType{data}
\name{nhl_data_hockey_reference}
\alias{nhl_data_hockey_reference}
\title{NHL Skater Statistics from Hockey Reference}
\format{
A data frame with 12375 rows and 49 variables:
\describe{
  \item{player}{Name}
  \item{age}{Age}
  \item{tm}{Team}
  \item{pos}{Position}
  \item{gp}{Games played}
  \item{g}{Goals}
  \item{a}{Assists}
  \item{pts}{Goals plus Assists (Points)}
  \item{x}{Plus Minus}
  \item{pim}{Penalties in minutes}
  \item{ps}{Point shares}
  \item{ev}{Even strength goals}
  \item{pp}{Power play goals}
  \item{sh}{Short handed goals}
  \item{gw}{Game winning goals}
  \item{eva}{Even strength assists}
  \item{ppa}{Power play assists}
  \item{sha}{Short handed assists}
  \item{s}{Shots on goal}
  \item{s_percent}{Shooting percentage}
  \item{toi}{Time on ice (minutes)}
  \item{atoi}{Average time on ice}
  \item{blk}{Blocks}
  \item{hit}{Hits}
  \item{fow}{Face offs won}
  \item{fol}{Face offs lost}
  \item{fo_percent}{Face off win percentage}
  \item{cf}{Corsi for }
  \item{ca}{Corsi against}
  \item{cf_percent}{Corsi for percent}
  \item{cf_percent_rel}{On-ice Corsi for percent minus off-ice Corsi for percent}
  \item{ff}{Fenwick for}
  \item{fa}{Fenwick against}
  \item{ff_percent}{Fenwick for percent}
  \item{ff_percent_rel}{On-ice Fenwick for percent minus off-ice Fenwick for percent}
  \item{oi_sh_percent}{Team on-ice shooting percentage}
  \item{oi_sv_percent}{Team on-ice save percentage}
  \item{pdo}{PDO}
  \item{o_zs_percent}{Offensive zone start percentage}
  \item{d_zs_percent}{Defensive zone start percentage}
  \item{toi_60}{Time on ice per 60 minutes}
  \item{toi_ev}{Time on ice per 60 minutes at even strength}
  \item{tk}{Takeaways}
  \item{gv}{Giveaways}
  \item{s_att}{Total shot attempts in all situations}
  \item{thru_percent}{Percentage of shots taken that go on net}
  \item{season}{Season}
  \item{e}{Expected plus minus}
}
}
\source{
\url{https://www.nhl.com/stats/}
}
\usage{
nhl_data_hockey_reference
}
\description{
A dataset containing NHL Skater Statistics
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nba_nuggets_shots.R
\docType{data}
\name{nba_nuggets_shots}
\alias{nba_nuggets_shots}
\title{2014/5 - 2022/23 Shot Data for the NBA's Denver Nuggets}
\format{
A data frame with 62196 rows and 27 variables:
\describe{
  \item{yearSeason}{Season in which the game was played (YYYY)}
  \item{slugSeason}{Season in which the game was played (YYYY-YY)}
  \item{idTeam}{Team ID on nba.com}
  \item{idPlayer}{Player ID on nba.com}
  \item{typeGrid}{A string showing grid type}
  \item{namePlayer}{Player name}
  \item{nameTeam}{Full team name}
  \item{typeEvent}{Made or Missed Shot}
  \item{typeAction}{Type of shot, e.g. Jump Shot}
  \item{typeShot}{Two or three point shot}
  \item{dateGame}{Date in YYYY-MM-DD}
  \item{slugTeamHome}{Home Team abbreviation}
  \item{slugTeamAway}{Away Team abbreviation}
  \item{idGame}{Game ID on nba.com}
  \item{idEvent}{Event ID within the game on nba.com}
  \item{numberPeriod}{Period in game in which the shot was taken}
  \item{minutesRemaining}{Minutes remaining in the period in which the shot was taken}
  \item{zoneBasic}{Description of area on court where shot was taken}
  \item{nameZone}{Name of the zone}
  \item{slugZone}{Abbreviation of shot zone}
  \item{zoneRange}{Distance of shot in categories}
  \item{locationX}{X cordinate where shot was taken}
  \item{locationY}{Y cordinate where shot was taken}
  \item{secondsRemaining}{Seconds remainin when shot was taken}
  \item{distanceShot}{Distance of the shot in feet}
  \item{isShotAttempted}{Logical for shot taken}
  \item{isShotMade}{Logical for make/miss of shot}
}
}
\source{
\url{http://asbcllc.com/nbastatR/reference/teams_shots.html}
}
\usage{
nba_nuggets_shots
}
\description{
A dataset containing seven seasons of Denver Nuggets shot data from NBA.com
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nba_games_2021.R
\docType{data}
\name{nba_games_2021}
\alias{nba_games_2021}
\title{2021 NBA Game Logs for the 2020-21 Season}
\format{
A data frame with 1832 rows and 47 variables:
\describe{
  \item{yearSeason}{Season in which the game was played (YYYY)}
  \item{slugSeason}{Season in which the game was played (YYYY-YY)}
  \item{slugLeague}{Always given as NBA}
  \item{typeSeason}{Regular season data}
  \item{dateGame}{Date in YYYY-MM-DD}
  \item{idGame}{Game ID on nba.com}
  \item{numberGameTeamSeason}{slugTeam game number in the season}
  \item{nameTeam}{Full team name}
  \item{idTeam}{Team ID on nba.com}
  \item{isB2B}{Logical for back-to-back game}
  \item{isB2BFirst}{Logical for first game of back-to-back game}
  \item{isB2BSecond}{Logical for second game of back-to-back game}
  \item{locationGame}{Home (H) or Away (A)}
  \item{slugMatchup}{Team One vs. Team Two}
  \item{slugTeam}{Team abbreviation}
  \item{countDaysRestTeam}{Days between previous game and this game}
  \item{countDaysNextGameTeam}{Days until next game}
  \item{slugOpponent}{Opponent abbreviation}
  \item{slugTeamWinner}{Team that won (abbreviation)}
  \item{slugTeamLoser}{Team that lost (abbreviation)}
  \item{outcomeGame}{Result for slugTeam (W or L)}
  \item{isWin}{Logical for slugTeam winning}
  \item{fgmTeam}{slugTeam field goals made}
  \item{fgaTeam}{slugTeam field goal attempts}
  \item{pctFGTeam}{slugTeam field goal percentage}
  \item{fg3mTeam}{slugTeam three point field goals made}
  \item{fg3aTeam}{slugTeam three point field goal attempts}
  \item{pctFG3Team}{slugTeam three point field goal percentage}
  \item{pctFTTeam}{slugTeam free throw percentage}
  \item{hasVideo}{Logical if game video exists}
  \item{fg2mTeam}{slugTeam two point field goals made}
  \item{fg2aTeam}{slugTeam two point field goal attempts}
  \item{pctFG2Team}{slugTeam two point field goal percentage}
  \item{minutesTeam}{Total minutes played}
  \item{ftmTeam}{slugTeam free throws made}
  \item{ftaTeam}{slugTeam free throw attempts}
  \item{orebTeam}{slugTeam offensive rebounds}
  \item{drebTeam}{slugTeam defensive rebounds}
  \item{trebTeam}{slugTeam total rebounds}
  \item{astTeam}{slugTeam total assists}
  \item{stlTeam}{slugTeam total steals}
  \item{blkTeam}{slugTeam total blocks}
  \item{tovTeam}{slugTeam total turnovers}
  \item{pfTeam}{slugTeam total personal fouls}
  \item{ptsTeam}{slugTeam total points scored}
  \item{plusminusTeam}{Margin of game as slugTeam score minus slugOpponent score}
  \item{urlTeamSeasonLogo}{url of slugTeam logo}
}
}
\source{
\url{http://asbcllc.com/nbastatR/reference/game_logs.html}
}
\usage{
nba_games_2021
}
\description{
A dataset containing the NBA Games table on nba.com
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/masters_2025.R
\docType{data}
\name{masters_2025}
\alias{masters_2025}
\title{2025 Masters Tournament Scores}
\format{
A data frame with 95 rows and 9 variables:
\describe{
  \item{pos}{finishing position for a player}
  \item{player_name}{name of the golfer}
  \item{nationality}{nationality of the golfer}
  \item{score}{final score relative to par}
  \item{round_1}{number of strokes from the first round}
  \item{round_2}{number of strokes from the second round}
  \item{round_3}{number of strokes from the third round}
  \item{round_4}{number of strokes from the fourth round}
  \item{total}{total strokes from all rounds}
}
}
\source{
\url{https://www.espn.com/golf/leaderboard/_/tournamentId/401703504}
}
\usage{
masters_2025
}
\description{
A data frame containing the scores from the 2025 Masters Golf Tournament.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/avs_stats_2022.R
\docType{data}
\name{avs_stats_2022}
\alias{avs_stats_2022}
\title{NHL's Colorado Avalanche Player Statistics}
\format{
A data frame with 162 rows and 50 variables:
\describe{
  \item{person_id}{NHL API Player ID}
  \item{person_full_name}{Player full name}
  \item{season}{Season}
  \item{season_start}{Season start}
  \item{stat_assists}{Assists}
  \item{stat_goals}{Goals}
  \item{stat_pim}{Penalty minutes}
  \item{stat_games}{Games played}
  \item{stat_penalty_minutes}{Penalty minutes}
  \item{stat_plus_minus}{Plus-minus value}
  \item{stat_points}{Points }
  \item{stat_power_play_goals}{Power play goals}
  \item{stat_game_winning_goals}{Game winning goals}
  \item{stat_short_handed_goals}{Short handed goals}
  \item{stat_shots}{Shots}
  \item{stat_shot_pct}{Shot percentage}
  \item{stat_time_on_ice}{Time on ice}
  \item{stat_hits}{Hits}
  \item{stat_power_play_points}{Power play points}
  \item{stat_power_play_time_on_ice}{Power play time on ice}
  \item{stat_even_time_on_ice}{Even play time on ice}
  \item{stat_face_off_pct}{Face off percentage}
  \item{stat_over_time_goals}{Overtime goals}
  \item{stat_short_handed_points}{Short handed points}
  \item{stat_short_handed_time_on_ice}{Short handed time on ice}
  \item{stat_blocked}{Blocks}
  \item{stat_shifts}{Shifts}
  \item{stat_save_percentage}{Save percentage}
  \item{stat_goal_against_average}{Goals against average}
  \item{stat_ot}{OT}
  \item{stat_shutouts}{Shutouts}
  \item{stat_ties}{Ties}
  \item{stat_wins}{Wins}
  \item{stat_losses}{Losses}
  \item{stat_saves}{Saves}
  \item{stat_power_play_saves}{Power play saves}
  \item{stat_short_handed_saves}{Short handed saves}
  \item{stat_even_saves}{Even play saves}
  \item{stat_short_handed_shots}{Short handed shots}
  \item{stat_even_shots}{Even play shots}
  \item{stat_power_play_shots}{Power play shots}
  \item{stat_games_started}{Games started}
  \item{stat_shots_against}{Shots against}
  \item{stat_goals_against}{Goals against}
  \item{stat_power_play_save_percentage}{Power play save percentage}
  \item{stat_short_handed_save_percentage}{Short handed save percentage}
  \item{stat_even_strength_save_percentage}{Even strength save percentage}
  \item{team_name}{Team name}
  \item{team_link}{Team link}
  \item{team_id}{Team ID}
}
}
\source{
\url{https://www.nhl.com/stats/}
}
\usage{
avs_stats_2022
}
\description{
A dataset containing the statistics for all Colorado Avalanche players on the 2022-23 roster
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wnba_seattle_pbp_2024.R
\docType{data}
\name{wnba_seattle_pbp_2024}
\alias{wnba_seattle_pbp_2024}
\title{2024 WNBA Seattle Storm Shots}
\format{
A data frame with 5156 rows and 3 variables:
\describe{
.  \item{coordinate_x}{X Coordinate of Shot}
.  \item{coordinate_y}{Y Coordinate of Shot}
  \item{scoring_play}{Made or Missed Shot}
}
}
\source{
\url{https://wehoop.sportsdataverse.org}
}
\usage{
wnba_seattle_pbp_2024
}
\description{
A dataset containing all Seattle Storm shots in the 2024 season
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wnba_player_shots_2024.R
\docType{data}
\name{wnba_player_shots_2024}
\alias{wnba_player_shots_2024}
\title{2024 WNBA Player Shots}
\format{
A data frame with 3388 rows and 3 variables:
\describe{
  \item{athlete_display_name}{Player name}
.  \item{coordinate_x}{X Coordinate of Shot}
.  \item{coordinate_y}{Y Coordinate of Shot}
}
}
\source{
\url{https://wehoop.sportsdataverse.org}
}
\usage{
wnba_player_shots_2024
}
\description{
A dataset containing Breanna Stewart and A'ja Wilson's WNBA shots in the 2024 season
}
\keyword{datasets}
